import { right } from 'fp-ts/lib/Either';
import { catchError, map } from 'rxjs/operators';
import { of } from 'rxjs';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T, L
 * @param {?} recover
 * @return {?}
 */
function recoverWith(recover) {
    return function (source) { return source.pipe(map(function (v) { return right(v); }), catchError(function (error) { return recover(error); })); };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T, L
 * @param {?} selector
 * @return {?}
 */
function recover(selector) {
    return recoverWith(function (error) { return of(selector(error)); });
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { recoverWith, recover };

//# sourceMappingURL=rxjs-fp-operators.js.map